/**
 * ============================================================================
 * 				League of Northgard
 *
 * Thanks for giving me some good ideas on how to code certain things to the Creator of "Mount Doomed" - check out this map here:
 *
 * https://steamcommunity.com/sharedfiles/filedetails/?id=2169950278
 *
 * =============================================================================
 */



// --- Saved variables ---
// You can add what you want to the save
savedInt 		= 0; // Here is the initialization for the first launch, after that the value will depend on what has been saved

function saveState() {
	state.scriptProps = {
		savedInt 		: savedInt,
	};
}

//TO-DO:
//Mercenaries in Zwischenteilen in der Mitte müssen sich bewegen -> funktioniert nicht
//game balance
//Entdeckungsfeature --> nach jedem besiegten Tower wird das nächste Gebiet aufgedeckt --> klappt nicht
//Custom Lore von anderen Clans möglich -> ja mit unlockTech
//Custom Torfin -> Item modification + buying items via shop
//Unit pathing im jungle verbessern






// --- Local variables ---
var localInt 				= 3;
var lastMonthSpawned = 0;
var minionsSpawnText = ["Mercenaries start spawning now!",
							"I am calling you to arms!",
							"Fight to drink your enemies blood in Valhalla!"];
 var minionsSpawnTextShown = false;
 var openingText = ["Welcome, bloodthirsty Warriors!", "Fight in the League of Northgard to prove yourselves!", "Build up your economy quickly - There is not much time left until the fight starts!"];
 var openingTextShown = false;
 var zonesSet = false;
 var randomEventShown = false;



var DATA = {
	island: {
	//first zone is always T1 tower, last one is the main zone of a player
		P1: [getZone(238), getZone(225), getZone(214), getZone(189), getZone(183)],
		P2: [getZone(152), getZone(135), getZone(121), getZone(111), getZone(103)],
		P3: [getZone(65), getZone(74), getZone(68), getZone(56), getZone(52)],
		P4: [getZone(267), getZone(270), getZone(279), getZone(277), getZone(281)],
		P5: [getZone(174), getZone(187), getZone(200), getZone(207), getZone(221)],
		P6: [getZone(91), getZone(116), getZone(130), getZone(151), getZone(161)],
	},



};



// --- Script code ---
function init() {
	if (state.time == 0)
		onFirstLaunch();
	onEachLaunch();
}

function onFirstLaunch() {
  addRules();
  //addRandomEvent();
  setVictory();
  
  var p1 = getZone(183).owner;
  var p2 = getZone(103).owner;
  var p3 = getZone(52).owner;
  var p4 = getZone(281).owner;
  var p5 = getZone(221).owner;
  var p6 = getZone(161).owner;
  
  setAlly(p1, p2);
  setAlly(p3, p2);
  setAlly(p4, p5);
  setAlly(p6, p5);
  openDialog();
 //unlockTech is also able to unlock non clan-specific Techs. They are not displayed but they work. (i.e. Torfin with Pillage is possible)
  p1.unlockTech(Tech.Pillage, true);
  p2.unlockTech(Tech.Pillage, true);
  p3.unlockTech(Tech.Pillage, true);
  p4.unlockTech(Tech.Pillage, true);
  p5.unlockTech(Tech.Pillage, true);
  p6.unlockTech(Tech.Pillage, true);
  
    
     // setObjectives(); // if you want to use Objectives API do it here, on first launch only
    
}

function onEachLaunch() {

}

// Regular update is called every 0.5s
function regularUpdate(dt : Float) {
  if(isHost()) {
        @split[
		    setTiles(),
            Minions(),
			creepsP1(),
			creepsP2(),
			creepsP3(),
			creepsP4(),
			creepsP5(),
			creepsP6(),
		    checkVictory(),		
            

            //checkAI(), --> Boost AI? Community Feedback?

        ];
		
		
	   
	  
     
	}
}

function addRules() {
	//adding conquest rules
	addRule(Rule.SkirmisherAccess);
	addRule(Rule.SkirmisherRuthless);
		
	
}

function addRandomEvent(){
var i = randomInt(3);

if(i == 0){
	addRule(Rule.ZombieDraugr);
		if(randomEventShown == false){
			randomEventShown = true;
			talk("LISTEN! The conquest rule ZombieDraugr is active for this game! Every Viking that dies has a chance to turn into a Zombie!", {name:"RandomEventGuy", who:Banner.Giant1});
		}
	}

if(i == 1){
	addRule(Rule.Eruptions);
		if(randomEventShown == false){
			randomEventShown = true;
			talk("LISTEN! The conquest rule Eruptions is active for this game. At the year 802 rocks will crush on your head!", {name:"RandomEventGuy", who:Banner.Giant1});
		}
	}

if(i == 2){
	addRule(Rule.Elevation);
		if(randomEventShown == false){
			randomEventShown = true;
			talk("LISTEN! The conquest rule Elevation is active for this game. A curse is among ur population and will haunt some of them!", {name:"RandomEventGuy", who:Banner.Giant1});
		}
	}
}

function setTiles(){

//Setting zones to - not colonizable
//allowColonize(zone:Zone, b:Bool):Void
//Allow or forbid the playze to colonize a specific zone. (Function of Player)

//Setting zones to - not scoutable  getZone( ).allowScouting = false;

//Setting zone building slots   getZone( ).maxBuildings = 20;

if(zonesSet == false){

zonesSet = true;

  var p1 = getZone(183).owner;
  var p2 = getZone(103).owner;
  var p3 = getZone(52).owner;
  var p4 = getZone(281).owner;
  var p5 = getZone(221).owner;
  var p6 = getZone(161).owner;
  
//Enemy Jungle Protection -> causes the game to crash on start!
var restrictScoutingZones = [262, 220, 199, 159, 101, 66, 125, 175];

for(z in restrictScoutingZones) {
  var zone = getZone(z);
  if(zone == null) {
    debug(z + " is a bad zone!");
    continue;
  }
  zone.allowScouting = false;
}

//getZone(262).allowScouting = false;
//getZone(220).allowScouting = false;
//getZone(199).allowScouting = false;
//getZone(159).allowScouting = false;
//getZone(101).allowScouting = false;
//getZone(66).allowScouting = false;
//getZone(125).allowScouting = false;
//getZone(175).allowScouting = false;


//P1 Setup
p1.allowColonize(getZone(256), false);
p1.allowColonize(getZone(248), false);
getZone(189).maxBuildings = 0;
getZone(214).maxBuildings = 0;
getZone(225).maxBuildings = 0;
getZone(238).maxBuildings = 0;
p1.allowColonize(getZone(175), false);
getZone(175).maxBuildings = 0;

getZone(183).maxBuildings = 5;
getZone(196).maxBuildings = 5;
getZone(170).maxBuildings = 5;
getZone(172).maxBuildings = 5;
getZone(157).maxBuildings = 5;


//P2 Setup
p2.allowColonize(getZone(168), false);
p2.allowColonize(getZone(154), false);
getZone(152).maxBuildings = 0;
getZone(135).maxBuildings = 0;
getZone(121).maxBuildings = 0;
getZone(111).maxBuildings = 0;
p2.allowColonize(getZone(125), false);
getZone(125).maxBuildings = 0;
p2.allowColonize(getZone(101), false);
getZone(101).maxBuildings = 0;

getZone(103).maxBuildings = 5;
getZone(93).maxBuildings = 5;
getZone(82).maxBuildings = 5;
getZone(90).maxBuildings = 5;
getZone(73).maxBuildings = 5;

//P3 Setup

p3.allowColonize(getZone(87), false);
p3.allowColonize(getZone(79), false);
getZone(65).maxBuildings = 0;
getZone(74).maxBuildings = 0;
getZone(68).maxBuildings = 0;
getZone(56).maxBuildings = 0;
p3.allowColonize(getZone(66), false);
getZone(66).maxBuildings = 0;

getZone(52).maxBuildings = 5;
getZone(44).maxBuildings = 5;
getZone(38).maxBuildings = 5;
getZone(29).maxBuildings = 5;
getZone(19).maxBuildings = 5;

//P4 Setup

p4.allowColonize(getZone(256), false);
p4.allowColonize(getZone(248), false);
getZone(277).maxBuildings = 0;
getZone(279).maxBuildings = 0;
getZone(270).maxBuildings = 0;
getZone(267).maxBuildings = 0;
p4.allowColonize(getZone(262), false);
getZone(262).maxBuildings = 0;

getZone(281).maxBuildings = 5;
getZone(300).maxBuildings = 5;
getZone(294).maxBuildings = 5;
getZone(271).maxBuildings = 5;
getZone(284).maxBuildings = 5;

//P5 Setup
p5.allowColonize(getZone(168), false);
p5.allowColonize(getZone(154), false);
getZone(174).maxBuildings = 0;
getZone(187).maxBuildings = 0;
getZone(200).maxBuildings = 0;
getZone(207).maxBuildings = 0;
p5.allowColonize(getZone(220), false);
getZone(220).maxBuildings = 0;
p5.allowColonize(getZone(199), false);
getZone(199).maxBuildings = 0;

getZone(221).maxBuildings = 5;
getZone(212).maxBuildings = 5;
getZone(242).maxBuildings = 5;
getZone(227).maxBuildings = 5;
getZone(247).maxBuildings = 5;

//P6 Setup

p6.allowColonize(getZone(87), false);
p6.allowColonize(getZone(79), false);
getZone(91).maxBuildings = 0;
getZone(116).maxBuildings = 0;
getZone(130).maxBuildings = 0;
getZone(151).maxBuildings = 0;
p6.allowColonize(getZone(159), false);
getZone(159).maxBuildings = 0;

getZone(161).maxBuildings = 5;
getZone(148).maxBuildings = 5;
getZone(176).maxBuildings = 5;
getZone(166).maxBuildings = 5;
getZone(184).maxBuildings = 5;

}
}


function Minions(){
var currentMonth = convertTimeToMonth(state.time);
	if(lastMonthSpawned != currentMonth){
	minionDialog();
	var mainZone1 = 183;
	var P1 = getZone(183).owner;
	var mainZone2 = 103;
	var P2 = getZone(103).owner;
	var mainZone3 = 52;
	var P3 = getZone(52).owner;
	var mainZone4 = 281;
	var P4 = getZone(281).owner;
	var mainZone5 = 221;
	var P5 = getZone(221).owner;
	var mainZone6 = 161;
	var P6 = getZone(161).owner;
	
	spawnCreeps(mainZone1, P1);
	spawnCreeps(mainZone2, P2);
	spawnCreeps(mainZone3, P3);
	spawnCreeps(mainZone4, P4);
	spawnCreeps(mainZone5, P5);
	spawnCreeps(mainZone6, P6);
	
	lastMonthSpawned = currentMonth;
	
    }
}

function spawnCreeps(zone:Int, playerSelected:Player) {
 if(getZone(zone).units.length <  26){
 //if(playerSelected.getMilitaryCount(getZone(zone), false, false) < 15)
    addFoes([{z:zone, u:Unit.Mercenary, nb:6}]);
	}
	
}


       
		
function creepsP1(){

		 @sync{  
		 launchAttackPlayer([getZone(183).getUnit(Unit.Mercenary)], getZone(281).owner);	
	     //launchAttack([getZone(183).getUnit(Unit.Mercenary)], [ 267, 270, 279, 277, 281], true);
      	 		 
		 if(getZone(267).owner == null){
		 launchAttack([getZone(267).getUnit(Unit.Mercenary)], [270, 279, 277, 281], true);
		 		 
		 }
		 
		 if(getZone(270).owner == null){
		 launchAttack([getZone(270).getUnit(Unit.Mercenary)], [279, 277, 281], true);
		 }
		 
		 if(getZone(279).owner == null){
		 launchAttack([getZone(279).getUnit(Unit.Mercenary)], [277, 281], true);
		 }
		 
		 if(getZone(277).owner == null){
		 launchAttack([getZone(277).getUnit(Unit.Mercenary)], [281], true);
		 }
		 		 
		 }
	  
}

function creepsP2(){
		 @sync{	  
		 launchAttackPlayer([getZone(103).getUnit(Unit.Mercenary)], getZone(221).owner);
		 
		 //launchAttack([getZone(103).getUnit(Unit.Mercenary)], [221], true); //wont work, since they cant find a path
		 //launchAttack([getZone(103).getUnit(Unit.Mercenary)], [174, 187, 200, 207, 221], true);
	     //launching these following attacks would crash the mod
		 //launchAttack([getZone(152).getUnit(Unit.Mercenary)], [174, 187, 200, 207, 221], true);
		 //launchAttack([getZone(168).getUnit(Unit.Mercenary)], [174, 187, 200, 207, 221], true);
		 //launchAttack([getZone(154).getUnit(Unit.Mercenary)], [174, 187, 200, 207, 221], true);
      	 
		 if(getZone(174).owner == null){
		 //launchAttack([getZone(174).getUnit(Unit.Mercenary)], [187, 200, 207, 221], true);
		 }
		 
		 if(getZone(187).owner == null){
		 //launchAttack([getZone(187).getUnit(Unit.Mercenary)], [200, 207, 221], true);	 
		 
		 }
		 
		 if(getZone(200).owner == null){
		 //launchAttack([getZone(200).getUnit(Unit.Mercenary)], [207, 221], true);
		 }
		 
		 if(getZone(207).owner == null){
		 //launchAttack([getZone(207).getUnit(Unit.Mercenary)], [221], true);
		 }
		 
		 
		 }
}

		
function creepsP3(){
	 	  
	   @sync{  	 
		 launchAttackPlayer([getZone(52).getUnit(Unit.Mercenary)], getZone(161).owner);
	     //launchAttack([getZone(52).getUnit(Unit.Mercenary)], [91, 116, 130, 151, 161], true);
      	 		 
		 if(getZone(91).owner == null){
		 launchAttack([getZone(91).getUnit(Unit.Mercenary)], [116, 130, 151, 161], true);
		 }
		 
		 if(getZone(116).owner == null){
		 launchAttack([getZone(116).getUnit(Unit.Mercenary)], [130, 151, 161], true);
		 }
		 
		 if(getZone(130).owner == null){
		 launchAttack([getZone(130).getUnit(Unit.Mercenary)], [151, 161], true);
		 }
		 
		 if(getZone(151).owner == null){
		 launchAttack([getZone(151).getUnit(Unit.Mercenary)], [161], true);
		 }
		 
		 
		 }
}


function creepsP4(){

	  @sync{  	
		 launchAttackPlayer([getZone(281).getUnit(Unit.Mercenary)], getZone(183).owner);
	     //launchAttack([getZone(281).getUnit(Unit.Mercenary)], [238, 225, 214, 189, 183], true);
      	 		 
		 if(getZone(238).owner == null){
		 launchAttack([getZone(238).getUnit(Unit.Mercenary)], [225, 214, 189, 183], true);
		 }
		 
		 if(getZone(225).owner == null){
		 launchAttack([getZone(225).getUnit(Unit.Mercenary)], [214, 189, 183], true);
		 }
		 
		 if(getZone(214).owner == null){
		 launchAttack([getZone(214).getUnit(Unit.Mercenary)], [189, 183], true);
		 }
		 
		 if(getZone(189).owner == null){
		 launchAttack([getZone(189).getUnit(Unit.Mercenary)], [183], true);
		 }
		 
		 }
}


function creepsP5(){
		
	     @sync{  
		 launchAttackPlayer([getZone(221).getUnit(Unit.Mercenary)], getZone(103).owner);
	     //launchAttack([getZone(221).getUnit(Unit.Mercenary)], [152, 135, 121, 111, 103], true);
      	 		 
		 if(getZone(152).owner == null){
		 launchAttack([getZone(152).getUnit(Unit.Mercenary)], [135, 121, 111, 103], true);
		 }
		 
		 if(getZone(135).owner == null){
		 launchAttack([getZone(135).getUnit(Unit.Mercenary)], [121, 111, 103], true);
		 }
		 
		 if(getZone(121).owner == null){
		 launchAttack([getZone(121).getUnit(Unit.Mercenary)], [111, 103], true);
		 }
		 
		 if(getZone(111).owner == null){
		 launchAttack([getZone(111).getUnit(Unit.Mercenary)], [103], true);
		 }
		 		 
		 }
}


function creepsP6(){
	 	  
	  @sync{  
		 launchAttackPlayer([getZone(161).getUnit(Unit.Mercenary)], getZone(52).owner);
	     //launchAttack([getZone(161).getUnit(Unit.Mercenary)], [65, 74, 68, 56, 52], true);
		 
      	 		 
		 if(getZone(65).owner == null){
		 launchAttack([getZone(65).getUnit(Unit.Mercenary)], [74, 68, 56, 52], true);
		 }
		 
		 if(getZone(74).owner == null){
		 launchAttack([getZone(74).getUnit(Unit.Mercenary)], [68, 56, 52], true);
		 }
		 
		 if(getZone(68).owner == null){
		 launchAttack([getZone(68).getUnit(Unit.Mercenary)], [56, 52], true);
		 }
		 
		 if(getZone(56).owner == null){
		 launchAttack([getZone(56).getUnit(Unit.Mercenary)], [52], true);
		 }
		 
		 }
	  
}

function checkVictory(){
//Top Team
  var player1 = getZone(196).owner;
  var player2 = getZone(93).owner;
  var player3 = getZone(44).owner;
//Bottom Team 
  var player4 = getZone(300).owner;
  var player5 = getZone(212).owner;
  var player6 = getZone(148).owner;
 
//Top Team wins ()
if(getZone(281).owner == null || getZone(221).owner == null || getZone(161).owner == null){
		 @sync{ 
		 player1.customVictory("Congratulations brave Warrior, your team wins the League of Northgard!", "Your enemies have been defeated.");
		 player2.customVictory("Congratulations brave Warrior, your team wins the League of Northgard!", "Your enemies have been defeated.");
		 player3.customVictory("Congratulations brave Warrior, your team wins the League of Northgard!", "Your enemies have been defeated.");
		 player4.customDefeat("Defeated! Your team lost the game.");
		 player5.customDefeat("Defeated! Your team lost the game.");
		 player6.customDefeat("Defeated! Your team lost the game.");
		 }
		 
 }

//Bottom Team wins ()
if(getZone(183).owner == null || getZone(103).owner == null || getZone(52).owner == null){
		 @sync{ 
		 player4.customVictory("Congratulations brave Warrior, your team wins the League of Northgard!", "Your enemies have been defeated.");
		 player5.customVictory("Congratulations brave Warrior, your team wins the League of Northgard!", "Your enemies have been defeated.");
		 player6.customVictory("Congratulations brave Warrior, your team wins the League of Northgard!", "Your enemies have been defeated.");
		 player1.customDefeat("Defeated! Your team lost the game.");
		 player2.customDefeat("Defeated! Your team lost the game.");
		 player3.customDefeat("Defeated! Your team lost the game.");
		 }
		 
 }

}


function minionDialog() {
	if(!minionsSpawnTextShown) {
		setPause(true);
		sfx(UiSfx.KrakenAttackAnnounce);
		shakeCamera(true);
		for(text in minionsSpawnText)
			talk(text, {name:"ODIN", who:Banner.BossFinalHidden});
		minionsSpawnTextShown = true;
		setPause(false);

	}
}

function openDialog() {
	if(!openingTextShown) {
		setPause(true);
		for(text in openingText)
			talk(text, {name:"LOKI", who:Banner.BossFinal});
		openingTextShown = true;
		setPause(false);

	}
}




/**
 * Given a Month and Year, it will return the number of real time seconds that
 * represents. A Month is defined as 60 seconds long. One year is therefore
 * 720 seconds or 12 minutes.
 */
function calToSeconds(month:Int, year:Int) {

	// 60 seconds per month, and 12 months in a year
	return month * 60 + year * 60 * 12;
}

/**
 * Given a time, will return what month we are in, where 0 = March and 12 = February
 */
function convertTimeToMonth(time:Float) {
	return toInt(time % 720 / 60);
}


function setVictory() {
    // Setup Dom only victory
    state.removeVictory(VictoryKind.VMoney);
    state.removeVictory(VictoryKind.VFame);
    state.removeVictory(VictoryKind.VLore);
}